#include "CommonDefines.h"

#define EXP_BUFFER_DIM 512
#define TOKEN_DIM 16

#ifndef TOKENIZER
#define TOKENIZER

typedef char ExpressionBuffer[EXP_BUFFER_DIM];

typedef char Token[TOKEN_DIM];

typedef enum
{
    None,
    Number,
    Symbol,
} TokenType;

typedef struct
{
    ExpressionBuffer buffer;
    Token currentToken;
    TokenType currentTokenType;
    int currentIdx;
} Tokenizer;

#endif

Tokenizer* newTokenizer(char expression[]);
void destroyTokenizer(Tokenizer *tokenizer);
boolean readNextToken(Tokenizer* tokenizer);
void getCurrentToken(Tokenizer* tokenizer, Token t);
TokenType getCurrentTokenType(Tokenizer* tokenizer);

void tokenizerTest();