#include <stdio.h>
#include <stdlib.h>
#include "stack_ve_sym.h"


SymbolStack newSymbolStack(void)
{
	SymbolStack s = (SymbolStack) malloc( sizeof(struct symbolStackStruct));
	s -> sp = 0;
	return s;
}

void destroySymbolStack(SymbolStack s)
{
    free(s);
}

boolean isEmptySymbolStack(SymbolStack s) 
{
	return (s -> sp) == 0;
}

boolean isFullSymbolStack(SymbolStack s) 
{
	return (s -> sp) == MAX_STACK_DIM;
}

void symbolPush(SymbolType e, SymbolStack s) 
{
    if ( ! isFullSymbolStack(s) ) 
    {
        s -> val[s->sp] = e;
        s->sp = s->sp + 1;
    }
    else
        perror("Errore: SymbolStack pieno");
}

SymbolType symbolPop(SymbolStack s) 
{
	if ( ! isEmptySymbolStack(s) ) 
    {
		s->sp = s->sp -1;
		return s->val[s->sp];
	}
	else 
    {
		perror("Errore: SymbolStack vuoto");
		exit(-1);
		/* cosa si potrebbe fare altrimenti? */
	}
}

SymbolType symbolPeek(SymbolStack s)
{
    if ( ! isEmptySymbolStack(s) ) 
    {
		return s->val[s->sp - 1];
	}
	else 
    {
		perror("Errore: SymbolStack vuoto");
		exit(-1);
		/* cosa si potrebbe fare altrimenti? */
	}
}

void printSymbolStack(SymbolStack s)
{ 
	int i = 0;
   /* se lo SymbolStack  vuoto */
   if (isEmptySymbolStack(s)) 
   {
      printf( "The SymbolStack is empty.\n\n" );
   }
   else 
   { 
      printf("The SymbolStack is:\n");
	  for (i=s->sp-1; i>-1; i--)
		  printf("%d --> ", s->val[i]); 
      printf("NULL\n\n");
   }
}